diff --git a/build/pymake/pymake/functions.py b/build/pymake/pymake/functions.py
index e53fb54726..a8b738b638 100644
--- a/build/pymake/pymake/functions.py
+++ b/build/pymake/pymake/functions.py
@@ -19,12 +19,11 @@ def emit_expansions(descend, *expansions):
 
         for e, is_func in expansion:
             if is_func:
-                for exp in e.expansions(True):
-                    yield exp
+                yield from e.expansions(True)
             else:
                 yield e
 
-class Function(object):
+class Function:
     """
     An object that represents a function call. This class is always subclassed
     with the following methods and attributes:
@@ -51,7 +50,7 @@ class Function(object):
         argc = len(self._arguments)
 
         if argc < self.minargs:
-            raise data.DataError("Not enough arguments to function %s, requires %s" % (self.name, self.minargs), self.loc)
+            raise data.DataError("Not enough arguments to function {}, requires {}".format(self.name, self.minargs), self.loc)
 
         assert self.maxargs == 0 or argc <= self.maxargs, "Parser screwed up, gave us too many args"
 
@@ -84,9 +83,9 @@ class Function(object):
             args.append(arg)
 
         if curly:
-            return '${%s %s}' % (self.name, ','.join(args))
+            return '${{{} {}}}'.format(self.name, ','.join(args))
 
-        return '$(%s %s)' % (self.name, ','.join(args))
+        return '$({} {})'.format(self.name, ','.join(args))
 
     def expansions(self, descend=False):
         """Obtain all expansions contained within this function.
@@ -117,7 +116,7 @@ class Function(object):
         return len(self._arguments)
 
     def __repr__(self):
-        return "%s<%s>(%r)" % (
+        return "{}<{}>({!r})".format(
             self.__class__.__name__, self.loc,
             ','.join([repr(a) for a in self._arguments]),
             )
@@ -160,7 +159,7 @@ class Function(object):
         return not self.__eq__(other)
 
 class VariableRef(Function):
-    AUTOMATIC_VARIABLES = set(['@', '%', '<', '?', '^', '+', '|', '*'])
+    AUTOMATIC_VARIABLES = {'@', '%', '<', '?', '^', '+', '|', '*'}
 
     __slots__ = ('vname', 'loc')
 
@@ -175,11 +174,11 @@ class VariableRef(Function):
     def resolve(self, makefile, variables, fd, setting):
         vname = self.vname.resolvestr(makefile, variables, setting)
         if vname in setting:
-            raise data.DataError("Setting variable '%s' recursively references itself." % (vname,), self.loc)
+            raise data.DataError("Setting variable '{}' recursively references itself.".format(vname), self.loc)
 
         flavor, source, value = variables.get(vname)
         if value is None:
-            log.debug("%s: variable '%s' was not set" % (self.loc, vname))
+            log.debug("{}: variable '{}' was not set".format(self.loc, vname))
             return
 
         value.resolve(makefile, variables, fd, setting + [vname])
@@ -197,7 +196,7 @@ class VariableRef(Function):
         return emit_expansions(descend, self.vname)
 
     def __repr__(self):
-        return "VariableRef<%s>(%r)" % (self.loc, self.vname)
+        return "VariableRef<{}>({!r})".format(self.loc, self.vname)
 
     def __eq__(self, other):
         if not isinstance(other, VariableRef):
@@ -222,14 +221,14 @@ class SubstitutionRef(Function):
     def resolve(self, makefile, variables, fd, setting):
         vname = self.vname.resolvestr(makefile, variables, setting)
         if vname in setting:
-            raise data.DataError("Setting variable '%s' recursively references itself." % (vname,), self.loc)
+            raise data.DataError("Setting variable '{}' recursively references itself.".format(vname), self.loc)
 
         substfrom = self.substfrom.resolvestr(makefile, variables, setting)
         substto = self.substto.resolvestr(makefile, variables, setting)
 
         flavor, source, value = variables.get(vname)
         if value is None:
-            log.debug("%s: variable '%s' was not set" % (self.loc, vname))
+            log.debug("{}: variable '{}' was not set".format(self.loc, vname))
             return
 
         f = data.Pattern(substfrom)
@@ -241,7 +240,7 @@ class SubstitutionRef(Function):
                            for word in value.resolvesplit(makefile, variables, setting + [vname])]))
 
     def to_source(self):
-        return '$(%s:%s=%s)' % (
+        return '$({}:{}={})'.format(
             self.vname.to_source(),
             self.substfrom.to_source(),
             self.substto.to_source())
@@ -251,8 +250,8 @@ class SubstitutionRef(Function):
                 self.substto)
 
     def __repr__(self):
-        return "SubstitutionRef<%s>(%r:%r=%r)" % (
-            self.loc, self.vname, self.substfrom, self.substto,)
+        return "SubstitutionRef<{}>({!r}:{!r}={!r})".format(
+            self.loc, self.vname, self.substfrom, self.substto)
 
     def __eq__(self, other):
         if not isinstance(other, SubstitutionRef):
@@ -325,7 +324,7 @@ class FilterFunction(Function):
                  for p in self._arguments[0].resolvesplit(makefile, variables, setting)]
 
         fd.write(' '.join([w for w in self._arguments[1].resolvesplit(makefile, variables, setting)
-                           if util.any((p.match(w) for p in plist))]))
+                           if util.any(p.match(w) for p in plist)]))
 
 class FilteroutFunction(Function):
     name = 'filter-out'
@@ -339,7 +338,7 @@ class FilteroutFunction(Function):
                  for p in self._arguments[0].resolvesplit(makefile, variables, setting)]
 
         fd.write(' '.join([w for w in self._arguments[1].resolvesplit(makefile, variables, setting)
-                           if not util.any((p.match(w) for p in plist))]))
+                           if not util.any(p.match(w) for p in plist)]))
 
 class SortFunction(Function):
     name = 'sort'
@@ -666,7 +665,7 @@ class CallFunction(Function):
     def resolve(self, makefile, variables, fd, setting):
         vname = self._arguments[0].resolvestr(makefile, variables, setting)
         if vname in setting:
-            raise data.DataError("Recursively setting variable '%s'" % (vname,))
+            raise data.DataError("Recursively setting variable '{}'".format(vname))
 
         v = data.Variables(parent=variables)
         v.set('0', data.Variables.FLAVOR_SIMPLE, data.Variables.SOURCE_AUTOMATIC, vname)
@@ -680,7 +679,7 @@ class CallFunction(Function):
             return
 
         if flavor == data.Variables.FLAVOR_SIMPLE:
-            log.warning("%s: calling variable '%s' which is simply-expanded" % (self.loc, vname))
+            log.warning("{}: calling variable '{}' which is simply-expanded".format(self.loc, vname))
 
         # but we'll do it anyway
         e.resolve(makefile, v, fd, setting + [vname])
@@ -781,12 +780,12 @@ class ShellFunction(Function):
         if makefile.env is not None and 'PATH' in makefile.env:
             os.environ['PATH'] = makefile.env['PATH']
 
-        log.debug("%s: running command '%s'" % (self.loc, ' '.join(cline)))
+        log.debug("{}: running command '{}'".format(self.loc, ' '.join(cline)))
         try:
             p = subprocess.Popen(cline, executable=executable, env=makefile.env, shell=False,
                                  stdout=subprocess.PIPE, cwd=makefile.workdir)
-        except OSError, e:
-            print >>sys.stderr, "Error executing command %s" % cline[0], e
+        except OSError as e:
+            print("Error executing command %s" % cline[0], e, file=sys.stderr)
             return
         finally:
             os.environ['PATH'] = oldpath
@@ -830,7 +829,7 @@ class InfoFunction(Function):
 
     def resolve(self, makefile, variables, fd, setting):
         v = self._arguments[0].resolvestr(makefile, variables, setting)
-        print v
+        print(v)
 
 functionmap = {
     'subst': SubstFunction,
diff --git a/build/pymake/pymake/globrelative.py b/build/pymake/pymake/globrelative.py
index 37ca28e068..3dbce4eb8a 100644
--- a/build/pymake/pymake/globrelative.py
+++ b/build/pymake/pymake/globrelative.py
@@ -7,7 +7,7 @@ Filename globbing like the python glob module with minor differences:
 """
 
 import os, re, fnmatch
-import util
+from . import util
 
 _globcheck = re.compile('[[*?]')
 
@@ -35,7 +35,7 @@ def glob(fsdir, path):
         if not os.path.isdir(fspath):
             continue
 
-        r.extend((util.normaljoin(dir, found) for found in globpattern(fspath, leaf)))
+        r.extend(util.normaljoin(dir, found) for found in globpattern(fspath, leaf))
 
     return r
 
@@ -62,7 +62,7 @@ def globpattern(dir, pattern):
                   if not leaf.startswith('.')]
 
     leaves = fnmatch.filter(leaves, pattern)
-    leaves = filter(lambda l: os.path.exists(util.normaljoin(dir, l)), leaves)
+    leaves = [l for l in leaves if os.path.exists(util.normaljoin(dir, l))]
 
     leaves.sort()
     return leaves
diff --git a/build/pymake/pymake/parser.py b/build/pymake/pymake/parser.py
index 4bff533688..56e3be6ce7 100644
--- a/build/pymake/pymake/parser.py
+++ b/build/pymake/pymake/parser.py
@@ -34,15 +34,15 @@ coming.
 """
 
 import logging, re, os, sys
-import data, functions, util, parserdata
+from . import data, functions, util, parserdata
 
 _log = logging.getLogger('pymake.parser')
 
 class SyntaxError(util.MakeError):
     pass
 
-_skipws = re.compile('\S')
-class Data(object):
+_skipws = re.compile(r'\S')
+class Data:
     """
     A single virtual "line", which can be multiple source lines joined with
     continuations.
@@ -108,7 +108,7 @@ _alltokens = re.compile(r'''\\*\# | # hash mark preceeded by any number of backs
                             :: |
                             (?:\$(?:$|[\(\{](?:%s)\s+|.)) | # dollar sign followed by EOF, a function keyword with whitespace, or any character
                             :(?![\\/]) | # colon followed by anything except a slash (Windows path detection)
-                            [=#{}();,|'"]''' % '|'.join(functions.functionmap.iterkeys()), re.VERBOSE)
+                            [=#{}();,|'"]''' % '|'.join(functions.functionmap.keys()), re.VERBOSE)
 
 def iterdata(d, offset, tokenlist, it):
     """
@@ -233,7 +233,7 @@ def itercommandchars(d, offset, tokenlist, it):
 
     yield s[offset:d.lend].replace('\n\t', '\n'), None, None, None
 
-_redefines = re.compile('\s*define|\s*endef')
+_redefines = re.compile(r'\s*define|\s*endef')
 def iterdefinelines(it, startloc):
     """
     Process the insides of a define. Most characters are included literally. Escaped newlines are treated
@@ -336,7 +336,7 @@ _conditionkeywords = {
     'ifndef': ifndef
     }
 
-_conditiontokens = tuple(_conditionkeywords.iterkeys())
+_conditiontokens = tuple(_conditionkeywords.keys())
 _conditionre = re.compile(r'(%s)(?:$|\s+)' % '|'.join(_conditiontokens))
 
 _directivestokenlist = _conditiontokens + \
@@ -347,7 +347,7 @@ _directivesre = re.compile(r'(%s)(?:$|\s+)' % '|'.join(_directivestokenlist))
 _varsettokens = (':=', '+=', '?=', '=')
 
 def _parsefile(pathname):
-    fd = open(pathname, "rU")
+    fd = open(pathname)
     stmts = parsestring(fd.read(), pathname)
     stmts.mtime = os.fstat(fd.fileno()).st_mtime
     fd.close()
@@ -375,7 +375,7 @@ def parsefile(pathname):
 # colon followed by anything except a slash (Windows path detection)
 _depfilesplitter = re.compile(r':(?![\\/])')
 # simple variable references
-_vars = re.compile('\$\((\w+)\)')
+_vars = re.compile(r'\$\((\w+)\)')
 
 def parsedepfile(pathname):
     """
@@ -641,7 +641,7 @@ _PARSESTATE_SUBSTFROM = 3   # expanding a variable expansion substitution "from"
 _PARSESTATE_SUBSTTO = 4     # expanding a variable expansion substitution "to" value
 _PARSESTATE_PARENMATCH = 5  # inside nested parentheses/braces that must be matched
 
-class ParseStackFrame(object):
+class ParseStackFrame:
     __slots__ = ('parsestate', 'parent', 'expansion', 'tokenlist', 'openbrace', 'closebrace', 'function', 'loc', 'varname', 'substfrom')
 
     def __init__(self, parsestate, parent, expansion, tokenlist, openbrace, closebrace, function=None, loc=None):
@@ -691,7 +691,7 @@ def parsemakesyntax(d, offset, stopon, iterfunc):
     while True: # this is not a for loop because `di` changes during the function
         assert stacktop is not None
         try:
-            s, token, tokenoffset, offset = di.next()
+            s, token, tokenoffset, offset = next(di)
         except StopIteration:
             break
 
diff --git a/build/pymake/pymake/parserdata.py b/build/pymake/pymake/parserdata.py
index 7b2e5443d5..e1368c237e 100644
--- a/build/pymake/pymake/parserdata.py
+++ b/build/pymake/pymake/parserdata.py
@@ -1,12 +1,12 @@
 import logging, re, os
-import data, parser, functions, util
+from . import data, parser, functions, util
 from cStringIO import StringIO
 from pymake.globrelative import hasglob, glob
 
 _log = logging.getLogger('pymake.data')
 _tabwidth = 4
 
-class Location(object):
+class Location:
     """
     A location within a makefile.
 
@@ -54,7 +54,7 @@ class Location(object):
         return Location(self.path, line, column)
 
     def __str__(self):
-        return "%s:%s:%s" % (self.path, self.line, self.column)
+        return "{}:{}:{}".format(self.path, self.line, self.column)
 
 def _expandwildcards(makefile, tlist):
     for t in tlist:
@@ -62,8 +62,7 @@ def _expandwildcards(makefile, tlist):
             yield t
         else:
             l = glob(makefile.workdir, t)
-            for r in l:
-                yield r
+            yield from l
 
 _flagescape = re.compile(r'([\s\\])')
 
@@ -76,7 +75,7 @@ def parsecommandlineargs(args):
     overrides = []
     stmts = StatementList()
     r = []
-    for i in xrange(0, len(args)):
+    for i in range(0, len(args)):
         a = args[i]
 
         vname, t, val = util.strpartition(a, ':=')
@@ -97,7 +96,7 @@ def parsecommandlineargs(args):
 
     return stmts, r, ' '.join(overrides)
 
-class Statement(object):
+class Statement:
     """
     Represents parsed make file syntax.
 
@@ -123,7 +122,7 @@ class Statement(object):
     def __ne__(self, other):
         return self.__eq__(other)
 
-class DummyRule(object):
+class DummyRule:
     __slots__ = ()
 
     def addcommand(self, r):
@@ -188,14 +187,14 @@ class Rule(Statement):
             context.currule = DummyRule()
             return
 
-        ispatterns = set((t.ispattern() for t in targets))
+        ispatterns = {t.ispattern() for t in targets}
         if len(ispatterns) == 2:
             raise data.DataError("Mixed implicit and normal rule", self.targetexp.loc)
         ispattern, = ispatterns
 
         deps = list(_expandwildcards(makefile, data.stripdotslashes(self.depexp.resolvesplit(makefile, makefile.variables))))
         if ispattern:
-            rule = data.PatternRule(targets, map(data.Pattern, deps), self.doublecolon, loc=self.targetexp.loc)
+            rule = data.PatternRule(targets, list(map(data.Pattern, deps)), self.doublecolon, loc=self.targetexp.loc)
             makefile.appendimplicitrule(rule)
         else:
             rule = data.Rule(deps, self.doublecolon, loc=self.targetexp.loc, weakdeps=False)
@@ -207,7 +206,7 @@ class Rule(Statement):
         context.currule = rule
 
     def dump(self, fd, indent):
-        print >>fd, "%sRule %s: %s" % (indent, self.targetexp, self.depexp)
+        print("{}Rule {}: {}".format(indent, self.targetexp, self.depexp, file=fd))
 
     def to_source(self):
         sep = ':'
@@ -219,7 +218,7 @@ class Rule(Statement):
         if len(deps) > 0 and not deps[0].isspace():
             sep += ' '
 
-        return '\n%s%s%s' % (
+        return '\n{}{}{}'.format(
             self.targetexp.to_source(escape_variables=True),
             sep,
             deps)
@@ -275,17 +274,17 @@ class StaticPatternRule(Statement):
 
         for t in targets:
             if data.Pattern(t).ispattern():
-                raise data.DataError("Target '%s' of a static pattern rule must not be a pattern" % (t,), self.targetexp.loc)
+                raise data.DataError("Target '{}' of a static pattern rule must not be a pattern".format(t), self.targetexp.loc)
             stem = pattern.match(t)
             if stem is None:
-                raise data.DataError("Target '%s' does not match the static pattern '%s'" % (t, pattern), self.targetexp.loc)
+                raise data.DataError("Target '{}' does not match the static pattern '{}'".format(t, pattern), self.targetexp.loc)
             makefile.gettarget(t).addrule(data.PatternRuleInstance(rule, '', stem, pattern.ismatchany()))
 
         makefile.foundtarget(targets[0])
         context.currule = rule
 
     def dump(self, fd, indent):
-        print >>fd, "%sStaticPatternRule %s: %s: %s" % (indent, self.targetexp, self.patternexp, self.depexp)
+        print("{}StaticPatternRule {}: {}: {}".format(indent, self.targetexp, self.patternexp, self.depexp, file=fd))
 
     def to_source(self):
         sep = ':'
@@ -299,7 +298,7 @@ class StaticPatternRule(Statement):
         if len(pattern) > 0 and pattern[0] not in (' ', '\t'):
             sep += ' '
 
-        return '\n%s%s%s:%s' % (
+        return '\n{}{}{}:{}'.format(
             self.targetexp.to_source(escape_variables=True),
             sep,
             pattern,
@@ -339,7 +338,7 @@ class Command(Statement):
         context.currule.addcommand(self.exp)
 
     def dump(self, fd, indent):
-        print >>fd, "%sCommand %s" % (indent, self.exp,)
+        print("{}Command {}".format(indent, self.exp, file=fd))
 
     def to_source(self):
         # Commands have some interesting quirks when it comes to source
@@ -438,7 +437,7 @@ class SetVariable(Statement):
             v.set(vname, flavor, self.source, value)
 
     def dump(self, fd, indent):
-        print >>fd, "%sSetVariable<%s> %s %s\n%s %r" % (indent, self.valueloc, self.vnameexp, self.token, indent, self.value)
+        print("{}SetVariable<{}> {} {}\n{} {!r}".format(indent, self.valueloc, self.vnameexp, self.token, indent, self.value, file=fd))
 
     def __eq__(self, other):
         if not isinstance(other, SetVariable):
@@ -452,7 +451,7 @@ class SetVariable(Statement):
 
     def to_source(self):
         chars = []
-        for i in xrange(0, len(self.value)):
+        for i in range(0, len(self.value)):
             c = self.value[i]
 
             # Literal # is escaped in variable assignment otherwise it would be
@@ -477,7 +476,7 @@ class SetVariable(Statement):
 
         # We handle the target-specific syntax first.
         if self.targetexp is not None:
-            return '%s: %s %s %s' % (
+            return '{}: {} {} {}'.format(
                 self.targetexp.to_source(),
                 self.vnameexp.to_source(),
                 self.token,
@@ -489,18 +488,18 @@ class SetVariable(Statement):
         # the variable must have come from a define.
         if value.count('\n') > 0 or (len(value) and value[0].isspace()):
             # The parser holds the token in vnameexp for whatever reason.
-            return '%sdefine %s\n%s\nendef' % (
+            return '{}define {}\n{}\nendef'.format(
                 prefix,
                 self.vnameexp.to_source(),
                 value)
 
-        return '%s%s %s %s' % (
+        return '{}{} {} {}'.format(
                 prefix,
                 self.vnameexp.to_source(),
                 self.token,
                 value)
 
-class Condition(object):
+class Condition:
     """
     An abstract "condition", either ifeq or ifdef, perhaps negated.
 
@@ -543,7 +542,7 @@ class EqCondition(Condition):
         return (r1 == r2) == self.expected
 
     def __str__(self):
-        return "ifeq (expected=%s) %s %s" % (self.expected, self.exp1, self.exp2)
+        return "ifeq (expected={}) {} {}".format(self.expected, self.exp1, self.exp2)
 
     def __eq__(self, other):
         if not isinstance(other, EqCondition):
@@ -580,7 +579,7 @@ class IfdefCondition(Condition):
         return (len(value) > 0) == self.expected
 
     def __str__(self):
-        return "ifdef (expected=%s) %s" % (self.expected, self.exp)
+        return "ifdef (expected={}) {}".format(self.expected, self.exp)
 
     def __eq__(self, other):
         if not isinstance(other, IfdefCondition):
@@ -651,14 +650,14 @@ class ConditionBlock(Statement):
             i += 1
 
     def dump(self, fd, indent):
-        print >>fd, "%sConditionBlock" % (indent,)
+        print("{}ConditionBlock".format(indent, file=fd))
 
         indent2 = indent + '  '
         for c, statements in self._groups:
-            print >>fd, "%s Condition %s" % (indent, c)
+            print("{} Condition {}".format(indent, c, file=fd))
             statements.dump(fd, indent2)
-            print >>fd, "%s ~Condition" % (indent,)
-        print >>fd, "%s~ConditionBlock" % (indent,)
+            print("{} ~Condition".format(indent, file=fd))
+        print("{}~ConditionBlock".format(indent, file=fd))
 
     def to_source(self):
         lines = []
@@ -681,7 +680,7 @@ class ConditionBlock(Statement):
         if len(self) != len(other):
             return False
 
-        for i in xrange(0, len(self)):
+        for i in range(0, len(self)):
             our_condition, our_statements = self[i]
             other_condition, other_statements = other[i]
 
@@ -709,9 +708,9 @@ class ConditionBlock(Statement):
             s = statement.exp.s
 
             if statement.expected:
-                return '%sifdef %s' % (prefix, s)
+                return '{}ifdef {}'.format(prefix, s)
 
-            return '%sifndef %s' % (prefix, s)
+            return '{}ifndef {}'.format(prefix, s)
 
         if isinstance(statement, EqCondition):
             args = [
@@ -750,9 +749,9 @@ class ConditionBlock(Statement):
                 body = '(%s)' % ','.join(args)
 
             if statement.expected:
-                return '%sifeq %s' % (prefix, body)
+                return '{}ifeq {}'.format(prefix, body)
 
-            return '%sifneq %s' % (prefix, body)
+            return '{}ifneq {}'.format(prefix, body)
 
         if isinstance(statement, ElseCondition):
             return 'else'
@@ -793,7 +792,7 @@ class Include(Statement):
             makefile.include(f, self.required, loc=self.exp.loc, weak=self.weak)
 
     def dump(self, fd, indent):
-        print >>fd, "%sInclude %s" % (indent, self.exp)
+        print("{}Include {}".format(indent, self.exp, file=fd))
 
     def to_source(self):
         prefix = ''
@@ -801,7 +800,7 @@ class Include(Statement):
         if not self.required:
             prefix = '-'
 
-        return '%sinclude %s' % (prefix, self.exp.to_source())
+        return '{}include {}'.format(prefix, self.exp.to_source())
 
     def __eq__(self, other):
         if not isinstance(other, Include):
@@ -834,13 +833,13 @@ class VPathDirective(Statement):
             else:
                 dirs = []
                 for mpath in mpaths:
-                    dirs.extend((dir for dir in mpath.split(os.pathsep)
-                                 if dir != ''))
+                    dirs.extend(dir for dir in mpath.split(os.pathsep)
+                                 if dir != '')
                 if len(dirs):
                     makefile.addvpath(pattern, dirs)
 
     def dump(self, fd, indent):
-        print >>fd, "%sVPath %s" % (indent, self.exp)
+        print("{}VPath {}".format(indent, self.exp, file=fd))
 
     def to_source(self):
         return 'vpath %s' % self.exp.to_source()
@@ -885,7 +884,7 @@ class ExportDirective(Statement):
             makefile.exportedvars[v] = True
 
     def dump(self, fd, indent):
-        print >>fd, "%sExport (single=%s) %s" % (indent, self.single, self.exp)
+        print("{}Export (single={}, file=fd) {}".format(indent, self.single, self.exp))
 
     def to_source(self):
         return ('export %s' % self.exp.to_source()).rstrip()
@@ -915,7 +914,7 @@ class UnexportDirective(Statement):
             makefile.exportedvars[v] = False
 
     def dump(self, fd, indent):
-        print >>fd, "%sUnexport %s" % (indent, self.exp)
+        print("{}Unexport {}".format(indent, self.exp, file=fd))
 
     def to_source(self):
         return 'unexport %s' % self.exp.to_source()
@@ -947,7 +946,7 @@ class EmptyDirective(Statement):
             raise data.DataError("Line expands to non-empty value", self.exp.loc)
 
     def dump(self, fd, indent):
-        print >>fd, "%sEmptyDirective: %s" % (indent, self.exp)
+        print("{}EmptyDirective: {}".format(indent, self.exp, file=fd))
 
     def to_source(self):
         return self.exp.to_source()
@@ -958,7 +957,7 @@ class EmptyDirective(Statement):
 
         return self.exp == other.exp
 
-class _EvalContext(object):
+class _EvalContext:
     __slots__ = ('currule', 'weak')
 
     def __init__(self, weak):
@@ -1003,4 +1002,4 @@ def iterstatements(stmts):
         yield s
         if isinstance(s, ConditionBlock):
             for c, sl in s:
-                for s2 in iterstatments(sl): yield s2
+                yield from iterstatments(sl)
diff --git a/build/pymake/pymake/process.py b/build/pymake/pymake/process.py
index 01cadf5a99..f78d1f35e4 100644
--- a/build/pymake/pymake/process.py
+++ b/build/pymake/pymake/process.py
@@ -45,7 +45,7 @@ _unquoted_tokens = tokens2re({
 _doubly_quoted_tokens = tokens2re({
   'quote': '"',
   'backslashedquote': r'\\"',
-  'special': '\$',
+  'special': r'\$',
   'backslashed': r'\\[^\\"]',
 })
 
@@ -129,7 +129,7 @@ class ClineSplitter(list):
             elif 'special' in match:
                 # Unquoted, non-escaped special characters need to be sent to a
                 # shell.
-                raise MetaCharacterException, match['special']
+                raise MetaCharacterException(match['special'])
             elif 'whitespace' in match:
                 # Whitespaces terminate current argument.
                 self._next()
@@ -145,7 +145,7 @@ class ClineSplitter(list):
                 self.glob = True
                 self._push(m.group(0))
             else:
-                raise Exception, "Shouldn't reach here"
+                raise Exception("Shouldn't reach here")
         if self.arg:
             self._next()
 
@@ -153,17 +153,17 @@ class ClineSplitter(list):
         # Single quoted strings are preserved, except for the final quote
         index = self.cline.find("'")
         if index == -1:
-            raise Exception, 'Unterminated quoted string in command'
+            raise Exception('Unterminated quoted string in command')
         self._push(self.cline[:index])
         self.cline = self.cline[index+1:]
 
     def _parse_doubly_quoted(self):
         if not self.cline:
-            raise Exception, 'Unterminated quoted string in command'
+            raise Exception('Unterminated quoted string in command')
         while self.cline:
             m = _doubly_quoted_tokens.search(self.cline)
             if not m:
-                raise Exception, 'Unterminated quoted string in command'
+                raise Exception('Unterminated quoted string in command')
             self._push(self.cline[:m.start()])
             self.cline = self.cline[m.end():]
             match = dict([(name, value) for name, value in m.groupdict().items() if value])
@@ -175,7 +175,7 @@ class ClineSplitter(list):
                 # Unquoted, non-escaped special characters in a doubly quoted
                 # string still have a special meaning and need to be sent to a
                 # shell.
-                raise MetaCharacterException, match['special']
+                raise MetaCharacterException(match['special'])
             elif 'escape' in match:
                 # Escaped backslashes turn into a single backslash
                 self._push('\\')
@@ -194,7 +194,7 @@ def clinetoargv(cline, cwd):
     str = _escapednewlines.sub('', cline)
     try:
         args = ClineSplitter(str, cwd)
-    except MetaCharacterException, e:
+    except MetaCharacterException as e:
         return None, e.char
 
     if len(args) and args[0].find('=') != -1:
@@ -331,8 +331,8 @@ class PopenJob(Job):
                 os.environ['PATH'] = self.env['PATH']
             p = subprocess.Popen(self.argv, executable=self.executable, shell=self.shell, env=self.env, cwd=self.cwd)
             return p.wait()
-        except OSError, e:
-            print >>sys.stderr, e
+        except OSError as e:
+            print(e, file=sys.stderr)
             return -127
         finally:
             os.environ['PATH'] = oldpath
@@ -383,30 +383,30 @@ class PythonJob(Job):
                 try:
                     __import__(self.module)
                 except Exception as e:
-                    print >>sys.stderr, 'Error importing %s: %s' % (
+                    print('Error importing %s: %s' % (, file=sys.stderr)
                         self.module, e)
                     return -127
 
             m = sys.modules[self.module]
             if self.method not in m.__dict__:
-                print >>sys.stderr, "No method named '%s' in module %s" % (self.method, self.module)
+                print("No method named '%s' in module %s" % (self.method, self.module), file=sys.stderr)
                 return -127
             rv = m.__dict__[self.method](self.argv)
             if rv != 0 and rv is not None:
-                print >>sys.stderr, (
+                print((, file=sys.stderr)
                     "Native command '%s %s' returned value '%s'" %
                     (self.module, self.method, rv))
                 return (rv if isinstance(rv, int) else 1)
 
-        except PythonException, e:
-            print >>sys.stderr, e
+        except PythonException as e:
+            print(e, file=sys.stderr)
             return e.exitcode
         except:
             e = sys.exc_info()[1]
             if isinstance(e, SystemExit) and (e.code == 0 or e.code is None):
                 pass # sys.exit(0) is not a failure
             else:
-                print >>sys.stderr, e
+                print(e, file=sys.stderr)
                 traceback.print_exc()
                 return -127
         finally:
@@ -461,7 +461,7 @@ class ParallelContext(object):
 
     def _docall_generic(self, pool, job, cb, echo, justprint):
         if echo is not None:
-            print echo
+            print(echo)
         processcb = job.get_callback(ParallelContext._condition)
         if justprint:
             processcb(0)
@@ -525,7 +525,7 @@ class ParallelContext(object):
             for c in clist:
                 c.run()
 
-            dowait = util.any((len(c.running) for c in ParallelContext._allcontexts))
+            dowait = util.any(len(c.running) for c in ParallelContext._allcontexts)
             if dowait:
                 # Wait on local jobs first for perf
                 for job, cb in ParallelContext._waitany(ParallelContext._condition):
